/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

/**
 * Enums for possible values for handles of nodes in the query builder.
 * Possible handles for an entity node.
 */
// import { FunctionArgTypes } from '../logic/graphFunctions';

/** Links need handles to what they are connected to (and which side) */
export enum Handles {
  RelationLeft = 'relationLeftHandle', //target
  RelationRight = 'relationRightHandle', //source
  RelationAttribute = 'relationAttributeHandle', //source
  EntityLeft = 'entityLeftHandle', //source
  EntityRight = 'entityRightHandle', //target
  EntityAttribute = 'entityAttributeHandle', //source
  LogicLeft = 'leftLogicHandle',
  LogicRight = 'rightLogicHandle',
}

export function isRelationHandle(handle: Handles): boolean {
  return handle.startsWith(Handles.RelationLeft) || handle.startsWith(Handles.RelationRight);
}

export function isEntityHandle(handle: Handles): boolean {
  return handle.startsWith(Handles.EntityLeft) || handle.startsWith(Handles.EntityRight);
}

export function isLogicHandle(handle: Handles): boolean {
  return (
    handle.startsWith(Handles.LogicLeft) ||
    handle.startsWith(Handles.LogicRight) ||
    handle.startsWith(Handles.RelationAttribute) ||
    handle.startsWith(Handles.EntityAttribute)
  );
}
